instruction_maths_gsm = "Please convert natural language plans into a series of subgoals and their corresponding actions" \
                "that lead to the successful implementation with respect to the given instructions. " \
                "Please use 'R[number]' to represent the intermediate results for each subgoal, without generating" \
                "any exact values. Please also use functions to represent the corresponding actions. " \
                "For the actions, they must be one of 'Calculator', 'SolveEquation', 'Count', and 'Define'.\n\n" \
                "Example 1:\n" \
                "Task: Peter goes to the store to buy a soda. The soda costs $.25 an ounch. He brought $2 with him and leaves with $.50. How many ounces of soda did he buy?\n\n" \
                "Natural language plan:\n" \
                "He spend $1.5 on soda because 2 - .5 = <<2-.5=1.5>>1.5 He bought 6 ounces of soda because 1.5 / .25 = <<6=6>>6\n\n" \
                "Subgoal-based plan:\n" \
                "Subgoal 1: Calculate how much the soda costs in total.\n" \
                "Action 1-1: R1 = Calculator(2 - 0.5) = 1.5 \n\n" \
                "Subgoal 2: Calculate the ounces of soda the price per ounch.\n" \
                "Action 2-1: R2 = Calculator(R1 / 0.25) = 6 \n\n" \
                "Example 2:\n" \
                "Task: Leah earned $28 working odd jobs around the neighborhood. She spent a seventh of it on a milkshake and put half of the rest in her savings account. She left the remaining money in her wallet. Her dog got ahold of her wallet and shredded all the money inside but $1. How many dollars did Leah lose?\n\n" \
                "Natural language plan: Leah spent 28 * 1/7 = $<<28/7=4>>4 on a milkshake. She had 28 - 4 = $<<28-4=24>>24 left. She put half in her savings account and half in her wallet, so she had 24 / 2 = $<<24/2=12>>12 in her wallet. Her dog shredded all the money in her wallet but $1, so Leah lost 12 - 1 = $<<12-1=11>>11.\n\n" \
                "Subgoal-based plan:\n" \
                "Subgoal 1: Calculate the amount Leah spent on milkshake.\n" \
                "Action 1-1: R1 = Calculator(28 * 1/7) = 4 \n\n" \
                "Subgoal 2: Calculate Leah's rest money after buying milkshake.\n" \
                "Action 2-1: R2 = Calculator(28 - R1) = 24 \n\n" \
                "Subgoal 3: Calculate the amount Leah spent in her savings account.\n" \
                "Action 3-1: R3 = Calculator(R2 / 2) = 12 \n\n" \
                "Subgoal 4: Calculate the amount Leah remained in her wallet.\n" \
                "Action 4-1: R4 = Calculator(R2 - R3) = 12 \n\n" \
                "Subgoal 5: Calculate the amount Leah lost after her dog shredded all the money in her wallet.\n" \
                "Action 5-1: R5 = Calculator(R4 - 1) = 11 \n\n" \
                "Example 3:\n" \
                "Task: Mrs. Snyder used to spend 40% of her monthly income on rent and utilities. Her salary was recently increased by $600 so now her rent and utilities only amount to 25% of her monthly income. How much was her previous monthly income?\n\n" \
                "Natural language plan:\n" \
                "Let her previous monthly income be p The cost of her rent and utilities was 40% of p which is (40/100)*p = 2p/5 Her income was increased by $600 so it is now p+$600 The cost of her rent and utilities now amount to 25% of (p+$600) which is (25/100)*(p+$600) = (p+$600)/4 Equating both expressions for cost of rent and utilities: 2p/5 = (p+$600)/4 Multiplying both sides of the equation by 20 gives 8p = 5p+$3000 Subtracting 5p from both sides gives: 3p = $3000 Dividing both sides by 3 gives p = $1000\n\n" \
                "Subgoal-based plan:\n" \
                "Subgoal 1: Define Snyder's previous monthly income be p.\n" \
                "Action 1-1: R1 = Define(p) = p \n\n" \
                "Subgoal 2: Calculate the amount that Mrs. Snyder used to spend for rent and utilities in terms of p.\n" \
                "Action 2-1: R2 = Calculator(40% * p) = 2p/5 \n\n" \
                "Subgoal 3: Calculate the increased salary.\n" \
                "Action 3-1: R3 = Calculator(p + 600) = p + 600 \n\n" \
                "Subgoal 4: Calculate the amount that Mrs. Snyder used to spend for rent and utilities based on the increased salary.\n" \
                "Action 4-1: R4 = Calculator(25% * R3) = (p + 600)/4 \n\n" \
                "Subgoal 5: Setup equations and solve p.\n" \
                "Action 5-1: R5 = SolveEquation(R2 = R4) = 1000 \n\n" \
                "Example 4:\n" \
                "Ralph is going to practice playing tennis with a tennis ball machine that shoots out tennis balls for Ralph to hit. He loads up the machine with 175 tennis balls to start with. Out of the first 100 balls, he manages to hit 2/5 of them. Of the next 75 tennis balls, he manages to hit 1/3 of them. Out of all the tennis balls, how many did Ralph not hit?\n\n" \
                "Natural language plan: Out of the first 100 balls, Ralph was able to hit 2/5 of them and not able to hit 3/5 of them, 3/5 x 100 = 60 tennis balls Ralph didn't hit. Out of the next 75 balls, Ralph was able to hit 1/3 of them and not able to hit 2/3 of them, 2/3 x 75 = 50 tennis balls that Ralph didn't hit. Combined, Ralph was not able to hit 60 + 50 = <<60+50=110>>110 tennis balls Ralph didn't hit.\n\n" \
                "Subgoal-based plan:\n" \
                "Subgoal 1: Calculate the tennis balls Ralph didn't hit for the first 100 balls.\n" \
                "Action 1-1: R1 = Calculator(1 - 2/5) = 3/5 \n" \
                "Action 1-2: R2 = Calculator(100 * R1) = 60 \n\n" \
                "Subgoal 2: Calculate the tennis balls Ralph didn't hit for the next 75 balls.\n" \
                "Action 2-1: R3 = Calculator(1 - 1/3) = 2/3 \n" \
                "Action 2-2: R4 = Calculator(75 * R3) = 50 \n\n" \
                "Subgoal 3: Calculate the total number of the tennis balls Ralph didn't hit.\n" \
                "Action 3-1: R5 = SolveEquation(R2 + R4) = 110 \n\n" \
                "Example 5:\n" \
                "Tina makes $18.00 an hour. If she works more than 8 hours per shift, she is eligible for overtime, which is paid by your hourly wage + 1/2 your hourly wage. If she works 10 hours every day for 5 days, how much money does she make?\n\n" \
                "Natural language plan: She works 8 hours a day for $18 per hour so she makes 8*18 = $<<8*18=144.00>>144.00 per 8-hour shift She works 10 hours a day and anything over 8 hours is eligible for overtime, so she gets 10-8 = <<10-8=2>>2 hours of overtime Overtime is calculated as time and a half so and she makes $18/hour so her overtime pay is 18*.5 = $<<18*.5=9.00>>9.00 Her overtime pay is 18+9 = $<<18+9=27.00>>27.00 Her base pay is $144.00 per 8-hour shift and she works 5 days and makes 5 * $144 = $<<144*5=720.00>>720.00 Her overtime pay is $27.00 per hour and she works 2 hours of overtime per day and makes 27*2 = $<<27*2=54.00>>54.00 in overtime pay 2 hours of overtime pay for 5 days means she makes 54*5 = $270.00 In 5 days her base pay is $720.00 and she makes $270.00 in overtime pay so she makes $720 + $270 = $<<720+270=990.00>>990.00\n\n" \
                "Subgoal-based plan:\n" \
                "Subgoal 1: Calculate the wage if she works 8 hours a day for $18 per hour.\n" \
                "Action 1-1: R1 = Calculator(8 * 18) = 144 \n\n" \
                "Subgoal 2: Calculate the amount of overtime if she works 10 hours.\n" \
                "Action 2-1: R2 = Calculator(10 - 8) = 2 \n\n" \
                "Subgoal 3: Calculate the overtime pay per hour.\n" \
                "Action 3-1: R3 = Calculator(18 + 1/2 * 18) = 27 \n\n" \
                "Subgoal 4: Calculate the overtime pay per day.\n" \
                "Action 4-1: R4 = Calculator(R2 * R3) = 54 \n\n" \
                "Subgoal 5: Calculate the base pay for 5 days.\n" \
                "Action 5-1: R5 = Calculator(R1 * 5) = 720 \n\n" \
                "Subgoal 6: Calculate the overtime pay for 5 days.\n" \
                "Action 6-1: R6 = Calculator(R4 * 5) = 270 \n\n" \
                "Subgoal 7: Calculate the total pay for 5 days.\n" \
                "Action 7-1: R7 = Calculator(R5 + R6) = 990 \n\n" \
                "Example 6:\n" \
                "Toby is counting goldfish in the local pond. He knows that only 25% of goldfish are at the surface and the rest are too deep below the surface to be able to see. If he counts 15 goldfish, how many are below the surface?\n\n" \
                "Natural language plan: There are 60 goldfish because 15 / .25 = <<15/.25=60>>60 There are 45 goldfish below the surface because 60 x (1-0.25) = <<60*(1-0.25)=45>>45\n\n" \
                "Subgoal-based plan:\n" \
                "Subgoal 1: Calculate the total number of goldfish in the local pond.\n" \
                "Action 1-1: R1 = Calculator(15 / 25%) = 60 \n\n" \
                "Subgoal 2: Calculate the ratio of goldfish below the surface.\n" \
                "Action 2-1: R2 = Calculator(1 - 25%) = 0.75 \n\n" \
                "Subgoal 3: Calculate the number of goldfish below the surface.\n" \
                "Action 3-1: R3 = Calculator(R1 * R2) = 45 \n\n" \
                "Now please help us generate a plan consisting of subgoals according to the following instruction and its natural language plan!\n\n"
                # "Example 3:\n" \
                # "Task: Let $\alpha$ and $\beta$ be the roots of $x^2 + px + 1 = 0,$ and let $\gamma$ and $\delta$ are the roots of $x^2 + qx + 1 = 0.$  Express \[(\alpha - \gamma)(\beta - \gamma)(\alpha + \delta)(\beta + \delta)\]in terms of $p$ and $q.$\n" \
                # "Natural language plan: Since $\alpha$ and $\beta$ are the roots of $x^2 + px + 1 = 0,$\[(x - \alpha)(x - \beta) = x^2 + px + 1.\]Setting $x = \gamma,$ we get\[(\gamma - \alpha)(\gamma - \beta) = \gamma^2 + p \gamma + 1.\]or $(\alpha - \gamma)(\beta - \gamma) = \gamma^2 + p \gamma + 1.$\n\n" \
                # "Setting $x = -\delta,$ we get\[(-\delta - \alpha)(-\delta - \beta) = \delta^2 - p \delta + 1,\]or $(\alpha + \beta)(\beta + \delta) = \delta^2 - p \delta + 1.\n\n$" \
                # "Since $\gamma$ and $\delta$ are the roots of $x^2 + qx + 1 = 0,$ $\gamma^2 + q \gamma + 1 = 0$ and $\delta^2 + q \delta + 1 = 0.$  Then \[\gamma^2 + p \gamma + 1 = (p - q) \gamma\]and\[\delta^2 - p \delta + 1 = -(p + q) \delta.\]Finally, by Vieta's formulas, $\gamma \delta = 1,$ so \[(p - q) \gamma \cdot (-(p + q)) \delta = (q - p)(q + p) = \boxed{q^2 - p^2}.\]" \
                # "Subgoal-based plan:\n" \
                # "Subgoal 1: Express the product of differences of roots in terms of the coefficients of the quadratic equations.\n" \
                # "Action 1-1: R1 = Calculator((x - α)(x - β))\n = (x - )" \
                # "Action 1-2: R2 = Calculator((x - γ)(x - δ))\n\n" \
                # "Subgoal 2: Substitute γ and -δ into the expressions obtained in Subgoal 1.\n" \
                # "Action 2-1: R3 = Calculator(R1(γ))\n" \
                # "Action 2-2: R4 = Calculator(R1(-δ))\n\n" \
                # "Subgoal 3: Express γ and δ in terms of q using the roots of the quadratic equations.\n" \
                # "Action 3-1: R5 = SetEquation(γ^2 + q*γ + 1 = 0)\n" \
                # "Action 3-2: R6 = SetEquation(δ^2 + q*δ + 1 = 0)\n\n" \
                # "Subgoal 4: Substitute the expressions obtained in Subgoal 3 into the expressions obtained in Subgoal 2.\n" \
                # "Action 4-1: R7 = Calculator(R3 - R5_left + R5_right)\n" \
                # "Action 4-2: R8 = Calculator(R4 - R6_left + R6_right)\n\n" \
                # "Subgoal 5: Use Vieta's formulas to express γδ in terms of p and q.\n" \
                # "Action 5-1: R9 = SetEquation(γδ = 1)\n\n" \
                # "Subgoal 6: Calculate the final expression using the results obtained in Subgoal 4 and Subgoal 5.\n" \
                # "Action 6-1: Output = Calculator(R7 * R8 * R9_right)\n\n" \