instruction_maths_prm = "Please convert natural language plans into a series of subgoals and their corresponding actions" \
                "that lead to the successful implementation with respect to the given instructions. " \
                "Please use 'R[number]' to represent the intermediate results for each subgoal, without generating" \
                "any exact values. Please also use functions to represent the corresponding actions. " \
                "For the actions, they must be one of 'Calculator', 'SetEquation', 'SolveEquation', 'Count', 'SolveInequality', 'Code', and 'Define'.\n\n" \
                "Example 1:\n" \
                "Instruction: The first four terms in an arithmetic sequence are $x+y$, $x-y$, $xy$, and $x/y$, in that order. What is the fifth term? Express your answer as a common fraction.\n\n" \
                "Natural language plan:\n" \
                "Since the difference of the first two terms is $-2y$, the third and fourth terms of the sequence must be $x-3y$ and $x-5y$. Thus \\[\nx-3y = xy \\quad\\text{and}\\quad x-5y = \\frac{x}{y},\n\\]so $xy - 5y^{2} = x.$ Combining these equations we obtain \\[\n(x - 3y) - 5y^{2}= x\\quad\\text{and, therefore, }\\quad -3y - 5y^{2} = 0.\n\\]Since $y$ cannot be 0, we have $y = -\\frac{3}{5}$, and it follows that $x = -\\frac{9}{8}$. The fifth term in the sequence is $x - 7y\n= \\boxed{\\frac{123}{40}}$.\n\n" \
                "Subgoal-based plan:\n" \
                "Subgoal 1: Calculate the difference between two consecutive terms in the sequence.\n" \
                "Action 1-1: R1 = Calculator((x-y) - (x+y)) = -2y \n\n" \
                "Subgoal 2: Calculate the third, fourth and fifth terms according to the calculated difference.\n" \
                "Action 2-1: R2 = Calculator((x+y) + 2*R1) = x-3y \n" \
                "Action 2-2: R3 = Calculator((x+y) + 3*R1) = x-5y \n" \
                "Action 2-3: R4 = Calculator((x+y) + 4*R1) = x-7y \n\n" \
                "Subgoal 3: Solve x and y by solving equations.\n" \
                "Action 3-1: R5, R6 = SolveEquation(R2=xy, R3=x/y) = -9/8, -3/5 \n\n" \
                "Subgoal 4: Calculate the real value of the fifth term using x and y values.\n" \
                "Action 4-1: Output = Calculator(R4(R5, R6)) = 123/40 \n\n" \
                "Example 2:\n" \
                "Task: How many positive integers less than or equal to 100 have a prime factor that is greater than 4?\n\n" \
                "Natural language plan: The easiest solution is to find the number of positive integers with only 2 and 3 as their prime factors. If the number has no factors of 3, the qualifying numbers are $2^0, 2^1, 2^2, 2^3, 2^4, 2^5, 2^6$ for 7 total. If there is one factor of 3, we have $2^0 \cdot 3^1, 2^1 \cdot 3^1, 2^2 \cdot 3^1, 2^3 \cdot 3^1, 2^4 \cdot 3^1, 2^5 \cdot 3^1$ for 6 total. With two factors of 3, we have $2^0 \cdot 3^2, 2^1 \cdot 3^2, 2^2 \cdot 3^2, 2^3 \cdot 3^2$ for 4 total. With three factors of 3, we have $2^0 \cdot 3^3, 2^1 \cdot 3^3$ for 2 total. Finally, $3^4$ gives us 1 more. So, there are $7+ 6+4+2+1 = 20$ positive integers less than or equal to 100 that have only 2 and 3 as prime factors. Therefore, there are $100-20 = \boxed{80}$ positive integers less than or equal to 100 that have a prime factor greater than 4.\n\n" \
                "Subgoal-based plan:\n" \
                "Subgoal 1: Calculate the number of positive integers with only 2 as their prime factor.\n" \
                "Action 1-1: R1 = Count(2^0, 2^1, 2^2, 2^3, 2^4, 2^5, 2^6) = 7 \n\n" \
                "Subgoal 2: Calculate the number of positive integers with 2 and 3 as their prime factors, with one factor of 3.\n" \
                "Action 2-1: R2 = Count(2^0 * 3^1, 2^1 * 3^1, 2^2 * 3^1, 2^3 * 3^1, 2^4 * 3^1, 2^5 * 3^1) = 6 \n\n" \
                "Subgoal 3: Calculate the number of positive integers with 2 and 3 as their prime factors, with two factors of 3.\n" \
                "Action 3-1: R3 = Count(2^0 * 3^2, 2^1 * 3^2, 2^2 * 3^2, 2^3 * 3^2) = 4 \n\n" \
                "Subgoal 4: Calculate the number of positive integers with 2 and 3 as their prime factors, with three factors of 3.\n" \
                "Action 4-1: R4 = Count(2^0 * 3^3, 2^1 * 3^3) = 2 \n\n" \
                "Subgoal 5: Calculate the number of positive integers with 3 as their prime factor, with four factors of 3.\n" \
                "Action 5-1: R5 = Count(3^4) = 1 \n\n" \
                "Subgoal 6: Calculate the total number of positive integers less than or equal to 100 that have only 2 and 3 as prime factors.\n" \
                "Action 6-1: R6 = Calculator(R1 + R2 + R3 + R4 + R5) = 20 \n\n" \
                "Subgoal 7: Calculate the number of positive integers less than or equal to 100 that have a prime factor greater than 4.\n" \
                "Action 7-1: Output = Calculator(100 - R6) = 80 \n\n" \
                "Example 3:\n" \
                "The sum of the squares of three consecutive positive even numbers is $12296$. Find the product of the three numbers divided by $8$.\n\n" \
                "Natural language plan: If $n$ is the middle number of the three, the other two numbers are $n-2$ and $n+2$. Therefore, the squares are $n^2-4n+4$, $n^2$, and $n^2+4n+4$. Setting the sum of the three squares equal to $12296$. Because $n$ is positive, $n$ must be $64$. Therefore, the set of numbers is $62, 64, 66$. The product of those is $261888$. The product divided by 8 is $\boxed{32736}$.\n\n" \
                "Subgoal-based plan:\n" \
                "Subgoal 1: Define the three consecutive even numbers in terms of n.\n" \
                "Action 1-1: R1 = Define(n-2) = n-2 \n" \
                "Action 1-2: R2 = Define(n) = n \n" \
                "Action 1-3: R3 = Define(n+2) = n+2 \n\n" \
                "Subgoal 2: Calculate the squares of the three numbers.\n" \
                "Action 2-1: R4 = Calculator(R1^2) = n^2-4n+4 \n" \
                "Action 2-2: R5 = Calculator(R2^2) = n^2 \n" \
                "Action 2-3: R6 = Calculator(R3^2) = n^2+4n+4 \n\n" \
                "Subgoal 3: Set up and solve the equation for the sum of the squares.\n" \
                "Action 3-1: R8 = SolveEquation(R4 + R5 + R6 = 12296) = 64 \n\n" \
                "Subgoal 4: Determine the positive solution for n.\n" \
                "Action 4-1: R9 = Code(If R8 > 0, R8, -R8) = 64 \n\n" \
                "Subgoal 5: Calculate the product of the three numbers.\n" \
                "Action 5-1: R10 = Calculator(R1(R9)) = 62 \n" \
                "Action 5-2: R11 = Calculator(R2(R9)) = 64 \n" \
                "Action 5-3: R12 = Calculator(R3(R9)) = 66 \n" \
                "Action 5-4: R13 = Calculator(R10 * R11 * R12) = 261888 \n\n" \
                "Subgoal 6: Divide the product by 8 to get the final answer.\n" \
                "Action 6-1: Output = Calculator(R13 / 8) = 32736 \n\n" \
                "Example 4:\n" \
                "For how many different digits $n$ is the three-digit number $14n$ divisible by $n$? Note: $14n$ refers to a three-digit number with the unit digit of $n,$ not the product of $14$ and $n.$\n\n" \
                "Natural language plan: We have to account for each possible value of $n$ here. First of all, we can quickly find that for $n = 1, 2, 5,$ the resulting number $14n$ must be divisible by $n$, using their respective divisibility rules.\n" \
                "We see that for $n = 3$, we get $143.$ Since $1 + 4 + 3 = 8,$ which is not a multiple of $3,$ we can see that $n = 3$ does not work. Moreover, if $143$ is not divisible by $3$, then $146$ and $149$ are not divisible by $3$ or any multiple of $3$, so $n = 6$ and $n = 9$ do not work.\n" \
                "For $n = 4$, we can see that $144$ is divisible by $4$ because $44$ is divisible by $4,$ so $n = 4$ works. For $n = 7$, we can easily perform division and see that $147$ is divisible by $7,$ so $n = 7$ works. For $n = 8$, we have little choice but to find that $\dfrac{148}{8} = \dfrac{37}{2},$ and so $n = 8$ does not work. All in all, we have that $n$ can be $1,$ $2,$ $4,$ $5,$ or $7,$ so we have $\boxed{5}$ possible choices for $n$ such that $14n$ is divisible by $n.$\n\n" \
                "Subgoal-based plan:\n" \
                "Subgoal 1: Check if the three-digit number 14n is divisible by n for n = 1, 2, 5.\n" \
                "Action 1-1: R1 = Code(If 141 % 1 == 0, 1, 0) = 1 \n" \
                "Action 1-2: R2 = Code(If 142 % 2 == 0, 1, 0) = 1 \n" \
                "Action 1-3: R3 = Code(If 145 % 5 == 0, 1, 0) = 1 \n\n" \
                "Subgoal 2: Check if the three-digit number 14n is divisible by n for n = 3, 6, 9.\n" \
                "Action 2-1: R4 = Code(If 143 % 3 == 0, 1, 0) = 0 \n" \
                "Action 2-2: R5 = Code(If 146 % 6 == 0, 1, 0) = 0 \n" \
                "Action 2-3: R6 = Code(If 149 % 9 == 0, 1, 0) = 0 \n\n" \
                "Subgoal 3: Check if the three-digit number 14n is divisible by n for n = 4, 7, 8.\n" \
                "Action 3-1: R7 = Code(If 144 % 4 == 0, 1, 0) = 1 \n" \
                "Action 3-2: R8 = Code(If 147 % 7 == 0, 1, 0) = 1 \n" \
                "Action 3-3: R9 = Code(If 148 % 8 == 0, 1, 0) = 0 \n\n" \
                "Subgoal 4: Calculate the total number of different digits n for which the three-digit number 14n is divisible by n.\n" \
                "Action 4-1: Output = Calculator(R1 + R2 + R3 + R4 + R5 + R6 + R7 + R8 + R9) = 5 \n\n" \
                "Now please help us generate a plan consisting of subgoals according to the following instruction and its natural language plan!\n\n"
                # "Example 3:\n" \
                # "Task: Let $\alpha$ and $\beta$ be the roots of $x^2 + px + 1 = 0,$ and let $\gamma$ and $\delta$ are the roots of $x^2 + qx + 1 = 0.$  Express \[(\alpha - \gamma)(\beta - \gamma)(\alpha + \delta)(\beta + \delta)\]in terms of $p$ and $q.$\n" \
                # "Natural language plan: Since $\alpha$ and $\beta$ are the roots of $x^2 + px + 1 = 0,$\[(x - \alpha)(x - \beta) = x^2 + px + 1.\]Setting $x = \gamma,$ we get\[(\gamma - \alpha)(\gamma - \beta) = \gamma^2 + p \gamma + 1.\]or $(\alpha - \gamma)(\beta - \gamma) = \gamma^2 + p \gamma + 1.$\n\n" \
                # "Setting $x = -\delta,$ we get\[(-\delta - \alpha)(-\delta - \beta) = \delta^2 - p \delta + 1,\]or $(\alpha + \beta)(\beta + \delta) = \delta^2 - p \delta + 1.\n\n$" \
                # "Since $\gamma$ and $\delta$ are the roots of $x^2 + qx + 1 = 0,$ $\gamma^2 + q \gamma + 1 = 0$ and $\delta^2 + q \delta + 1 = 0.$  Then \[\gamma^2 + p \gamma + 1 = (p - q) \gamma\]and\[\delta^2 - p \delta + 1 = -(p + q) \delta.\]Finally, by Vieta's formulas, $\gamma \delta = 1,$ so \[(p - q) \gamma \cdot (-(p + q)) \delta = (q - p)(q + p) = \boxed{q^2 - p^2}.\]" \
                # "Subgoal-based plan:\n" \
                # "Subgoal 1: Express the product of differences of roots in terms of the coefficients of the quadratic equations.\n" \
                # "Action 1-1: R1 = Calculator((x - α)(x - β))\n = (x - )" \
                # "Action 1-2: R2 = Calculator((x - γ)(x - δ))\n\n" \
                # "Subgoal 2: Substitute γ and -δ into the expressions obtained in Subgoal 1.\n" \
                # "Action 2-1: R3 = Calculator(R1(γ))\n" \
                # "Action 2-2: R4 = Calculator(R1(-δ))\n\n" \
                # "Subgoal 3: Express γ and δ in terms of q using the roots of the quadratic equations.\n" \
                # "Action 3-1: R5 = SetEquation(γ^2 + q*γ + 1 = 0)\n" \
                # "Action 3-2: R6 = SetEquation(δ^2 + q*δ + 1 = 0)\n\n" \
                # "Subgoal 4: Substitute the expressions obtained in Subgoal 3 into the expressions obtained in Subgoal 2.\n" \
                # "Action 4-1: R7 = Calculator(R3 - R5_left + R5_right)\n" \
                # "Action 4-2: R8 = Calculator(R4 - R6_left + R6_right)\n\n" \
                # "Subgoal 5: Use Vieta's formulas to express γδ in terms of p and q.\n" \
                # "Action 5-1: R9 = SetEquation(γδ = 1)\n\n" \
                # "Subgoal 6: Calculate the final expression using the results obtained in Subgoal 4 and Subgoal 5.\n" \
                # "Action 6-1: Output = Calculator(R7 * R8 * R9_right)\n\n" \