instruction_qa = "Please convert natural language plans into a series of subgoals and their corresponding actions" \
                "that lead to the successful implementation with respect to the given instructions. " \
                "Please use 'R[number]' to represent the intermediate results for each subgoal, without generating" \
                "any exact values. Please also use functions to represent the corresponding actions. " \
                "For the actions, they must be one of 'KnowledgeQuery', 'ParagraphRetrieve', 'QA', 'Calculator' and 'Code'.\n\n" \
                "Example 1:\n" \
                "Task: Are more people today related to Genghis Khan than Julius Caesar?\n\n" \
                "Natural language plan:\n" \
                "We find relevant facts: Julius Caesar had three children. Genghis Khan had sixteen children. Modern geneticists have determined that out of every 200 men today has DNA that can be traced to Genghis Khan. We need to answer these questions: 1. How many kids did Julius Caesar have? (Can be answered based on paragraph 'Julius Caesar-75') 2. How many kids did Genghis Khan have? (Can be answered based on paragraph 'Genghis Khan-17') 3. Is #2 greater than #1? Based on these evidences and decomposed questions, the answer is True. \n\n" \
                "Subgoal-based plan:\n" \
                "Subgoal 1: Obtain the number of the kids that Julius Caesar had.\n" \
                "Action 1-1: R1 = KnowledgeQuery(Julius Caesar) = WikipediaPage(Julius Caesar). \n" \
                "Action 1-2: R2 = ParagraphRetrieve(R1, Query: How many kids did Julius Caesar have?) = Paragraph(Julius Caesar-75). \n" \
                "Action 1-3: R3 = QA([R2], Question: How many kids did Julius Caesar have?) = 3. \n\n" \
                "Subgoal 2: Obtain the number of the kids that Genghis Khan had.\n" \
                "Action 2-1: R4 = KnowledgeQuery(Genghis Khan) = WikipediaPage(Genghis Khan). \n" \
                "Action 2-2: R5 = ParagraphRetrieve(R4, Query: How many kids did Genghis Khan have?) = Paragraph(Genghis Khan-17). \n" \
                "Action 2-3: R6 = QA([R5], Question: How many kids did Genghis Khan have?) = 16. \n\n" \
                "Subgoal 3: Determine if Genghis Khan had more kids.\n" \
                "Action 3-1: R7 = Calculator(R6 > R3) = True \n\n" \
                "Example 2:\n" \
                "Task: Would a Monoamine Oxidase candy bar cheer up a depressed friend?\n\n" \
                "Natural language plan:\n" \
                "We find relevant facts: Depression is caused by low levels of serotonin, dopamine and norepinephrine. Monoamine Oxidase breaks down neurotransmitters and lowers levels of serotonin, dopamine and norepinephrine. We need to answer these questions: 1. Depression is caused by low levels of what chemicals? (Can be answered based on paragraph 'Depression (mood)-13') 2. Monoamine Oxidase has an effect on what chemicals? (Can be answered based on paragraph 'Monoamine oxidase-8') 3. Of the chemicals listed in both #1 and #2, does Monoamine Oxidase raise their levels? (Can be answered based on paragraph 'Serotonin-36') Based on these evidences and decomposed questions, the answer is False. \n\n" \
                "Subgoal-based plan:\n" \
                "Subgoal 1: Answer low levels of what chemicals cause depression.\n" \
                "Action 1-1: R1 = KnowledgeQuery(depression) = WikipediaPage(Depression (mood)). \n" \
                "Action 1-2: R2 = ParagraphRetrieve(R1, Query: Depression is caused by low levels of what chemicals?) = Paragraph(Depression (mood)-13). \n" \
                "Action 1-3: R3 = QA([R2], Question: Depression is caused by low levels of what chemicals?) = serotonin, dopamine and norepinephrine. \n\n" \
                "Subgoal 2: Answer what chemicals Monoamine Oxidase has an effect on.\n" \
                "Action 2-1: R4 = KnowledgeQuery(Monoamine Oxidase) = WikipediaPage(Monoamine oxidase). \n" \
                "Action 2-2: R5 = ParagraphRetrieve(R4, Query: Monoamine Oxidase has an effect on what chemicals?) = Paragraph(Monoamine oxidase-8). \n" \
                "Action 2-3: R6 = QA([R5], Question: Monoamine Oxidase has an effect on what chemicals?) = serotonin, dopamine and norepinephrine. \n\n" \
                "Subgoal 3: Determine if Monoamine Oxidase raise the levels of these chemicals. \n" \
                "Action 3-1: R7 = QA([R3, R6], Question: Does Monoamine Oxidase raise the levels of these chemicals?) = False. \n\n" \
                "Example 3:\n" \
                "Task: Will the Albany in Georgia reach a hundred thousand occupants before the one in New York?\n\n" \
                "Natural language plan:\n" \
                "We find relevant facts: Albany, GA has around 75,000 people Albany, NY has almost 100,000 people We need to answer these questions: 1. What is the population of Albany, Georgia? (Can be answered based on paragraph 'Albany, Georgia-1') 2. What is the population of Albany, New York? (Can be answered based on paragraph 'Albany, New York-2') 3. What is the difference between 100,000 and #1? 4. What is the difference between 100,000 and #2? 5. Is #3 smaller than #4? Based on these evidences and decomposed questions, the answer is False. \n\n" \
                "Subgoal-based plan:\n" \
                "Subgoal 1: Obtain the population of Albany, Georgia.\n" \
                "Action 1-1: R1 = KnowledgeQuery(Albany, Georgia) = WikipediaPage(Albany, Georgia). \n" \
                "Action 1-2: R2 = ParagraphRetrieve(R1, Query: What is the population of Albany, Georgia?) = Paragraph(Albany, Georgia-1). \n" \
                "Action 1-3: R3 = QA([R2], Question: What is the population of Albany, Georgia?) = 75000. \n\n" \
                "Subgoal 2: Obtain the population of Albany, New York.\n" \
                "Action 2-1: R4 = KnowledgeQuery(Albany, New York) = WikipediaPage(Albany, New York). \n" \
                "Action 2-2: R5 = ParagraphRetrieve(R4, Query: What is the population of Albany, New York?) = Paragraph(Albany, New York-2). \n" \
                "Action 2-3: R6 = QA([R5], Question: What is the population of Albany, New York?) = 100000. \n\n" \
                "Subgoal 3: Calculate the difference between 100,000 and the population of Albany, Georgia. \n" \
                "Action 3-1: R7 = Calculator(100000 - R3) = 25000. \n\n" \
                "Subgoal 4: Calculate the difference between 100,000 and the population of Albany, New York. \n" \
                "Action 4-1: R8 = Calculator(100000 - R6) = 0. \n\n" \
                "Subgoal 5: Determine if the difference calculated in Subgoal 3 is smaller than the one calculated in Subgoal 4. \n" \
                "Action 5-1: R9 = Calculator(R7 < R8) = False. \n\n" \
                "Example 4:\n" \
                "Task: Would a dog respond to bell before Grey seal?\n\n" \
                "Natural language plan:\n" \
                "We find relevant facts: Grey seals have no ear flaps and their ears canals are filled with wax. Grey seals hear better underwater when their ears open like a valve. Dogs have sensitive ears that can hear as far as a quarter of a mile away. We need to answer these questions: 1. How sensitive is a grey seal's hearing on land? (Can be answered based on paragraph 'Pinniped-24') 2. How sensitive is a dog's hearing on land? (Can be answered based on paragraph 'Hearing range-11', 'Hertz-5') 3. Is #2 better than #1? Based on these evidences and decomposed questions, the answer is True. \n\n" \
                "Subgoal-based plan:\n" \
                "Subgoal 1: Answer how sensitive a grey seal's hearing on land is.\n" \
                "Action 1-1: R1 = KnowledgeQuery(grey seal's hearing) = WikipediaPage(Pinniped). \n" \
                "Action 1-2: R2 = ParagraphRetrieve(R1, Query: How sensitive is a grey seal's hearing on land?) = Paragraph(Pinniped-24). \n" \
                "Action 1-3: R3 = QA([R2], Question: How sensitive is a grey seal's hearing on land?) = Grey seals have no ear flaps and their ears canals are filled with wax. Grey seals hear better underwater when their ears open like a valve. \n\n" \
                "Subgoal 2: Answer how sensitive a dog's hearing on land is.\n" \
                "Action 2-1: R4 = KnowledgeQuery(dog's hearing) = WikipediaPage(Hearing range), WikipediaPage(Hertz). \n" \
                "Action 2-2: R5 = ParagraphRetrieve(R4, Query: How sensitive is a dog's hearing on land?) = Paragraph(Hearing range-11), Paragraph(Hertz-5). \n" \
                "Action 2-3: R6 = QA([R5], Question: How sensitive is a dog's hearing on land?) = Dogs have sensitive ears that can hear as far as a quarter of a mile away. \n\n" \
                "Subgoal 3: Determine if dog's hearing is better than Grey seal's. \n" \
                "Action 3-1: R7 = QA([R3, R6], Question: Is dog's hearing better than Grey seal's?) = True. \n\n" \
                "Example 5:\n" \
                "Task: Could the members of The Police perform lawful arrests?\n\n" \
                "Natural language plan:\n" \
                "We find relevant facts: The members of The Police were musicians, not law enforcement officers. Only law enforcement officers can perform lawful arrests. We need to answer these questions: 1. Who can perform lawful arrests? (Can be answered based on paragraph 'Arrest-2') 2. Are members of The Police also #1? (Can be answered based on paragraph 'Citizen's arrest-2', 'The Police-1') Based on these evidences and decomposed questions, the answer is False. \n\n" \
                "Subgoal-based plan:\n" \
                "Subgoal 1: Answer who can perform lawful arrests.\n" \
                "Action 1-1: R1 = KnowledgeQuery(lawful arrests) = WikipediaPage(Arrest). \n" \
                "Action 1-2: R2 = ParagraphRetrieve(R1, Query: Who can perform lawful arrests?) = Paragraph(Arrest-2). \n" \
                "Action 1-3: R3 = QA([R2], Question: Who can perform lawful arrests?) = law enforcement officers. \n\n" \
                "Subgoal 2: Answer if members of The Police are also law enforcement officers.\n" \
                "Action 2-1: R4 = KnowledgeQuery(The Police) = WikipediaPage(The Police), WikipediaPage(Citizen's arrest). \n" \
                "Action 2-2: R5 = ParagraphRetrieve(R4, Query: Are members of The Police also law enforcement officers?) = Paragraph(Citizen's arrest-2), Paragraph(The Police-1). \n" \
                "Action 2-3: R6 = QA([R5], Question: Are members of The Police also law enforcement officers?) = False. \n\n" \
                "Subgoal 3: Determine if the members of The Police can perform lawful arrests.\n" \
                "Action 3-1: R7 = QA([R3, R6], Question: Can the members of The Police perform lawful arrests) = False. \n\n" \
                "Now please help us generate a plan consisting of subgoals according to the following instruction and its natural language plan! \n\n"