instruction_web_agent = "Please convert natural language plans into a series of subgoals and their corresponding actions" \
                "that lead to the successful implementation with respect to the given instructions. " \
                "Please use 'R[number]' to represent the intermediate results for each subgoal, without generating" \
                "any exact values. Please also use functions to represent the corresponding actions. " \
                "For the actions, they must be one of 'TYPE', 'CLICK', and 'SELECT'.\n\n" \
                "Example 1:\n" \
                "Task: Book a flight + cruise flying from Atlanta in October for vacation starting on October 8 for 6 nights with Miami as the departure port, choose the cheapest flight, hotel, and room in the cruise for booking.\n\n" \
                "Natural language plan:\n" \
                "[span]  Flights + Cruise -> CLICK; [button]  Search flights + cruise External Link should open ... -> CLICK; [combobox]  Departing from -> TYPE: ATLANTA; [span]  Atlanta, GA (ATL) -> CLICK; [span]  Jun 2023 -> CLICK; [label]  October 08, 2023 -> CLICK; [span]  6 Nights -> SELECT; [label]  Miami -> CLICK; [button]  View details -> CLICK; [link]  Select package -> CLICK; [span]  Checkout -> CLICK \n\n" \
                "Subgoal-based plan:\n" \
                "Subgoal 1: Enter the site for flight + cruise.\n" \
                "Action 1-1: R1 = CLICK(Env, QUERY: Enter the site for flight + cruise). \n\n" \
                "Subgoal 2: Open the link for searching flights and cruise.\n" \
                "Action 2-1: R2 = CLICK(R1, QUERY: Open the link for searching flights and cruise). \n\n" \
                "Subgoal 3: Type Atlanta as the departure location.\n" \
                "Action 3-1: R3 = TYPE(R2, QUERY: Type Atlanta as the departure location, TEXT: Atlanta). \n\n" \
                "Subgoal 4: Choose the option Atlanta, GA (ATL) to fill the departure location.\n" \
                "Action 4-1: R4 = CLICK(R3, QUERY: Choose the option Atlanta, GA (ATL)). \n\n" \
                "Subgoal 5: Click the date region to set the departure date.\n" \
                "Action 5-1: R5 = CLICK(R4, QUERY: Click the date region to set the departure date). \n\n" \
                "Subgoal 6: Choose October 2023 as the departure date.\n" \
                "Action 6-1: R6 = CLICK(R5, QUERY: Choose October 08, 2023 as the departure date). \n\n" \
                "Subgoal 7: Set 6 nights as the living period for the hotel.\n" \
                "Action 7-1: R7 = SELECT(R6, QUERY: Click 6 nights as the living period for the hotel, TEXT: 6 nights). \n\n" \
                "Subgoal 8: Choose Miami as the destination.\n" \
                "Action 8-1: R8 = CLICK(R7, QUERY: Choose Miami as the destination). \n\n" \
                "Subgoal 9: Go to view details to proceed to checkout.\n" \
                "Action 9-1: R9 = CLICK(R8, QUERY: Go to view details to proceed to checkout). \n\n" \
                "Subgoal 10: Apply package to help us find cheapest flight, hotel and room.\n" \
                "Action 10-1: R10 = CLICK(R9, QUERY: Apply package to help us find cheapest flight, hotel and room). \n\n" \
                "Subgoal 11: Proceed to checkout.\n" \
                "Action 11-1: R11 = CLICK(R10, QUERY: Proceed to checkout). \n\n" \
                "Example 2:\n" \
                "Task: Find a Ricky Kej track to listen and share which has been added in the last year and is between 2 to 10 minutes.\n\n" \
                "Natural language plan:\n" \
                "[searchbox]  Search -> TYPE: Ricky Kej; [link]  Search for “Ricky Kej” -> CLICK; [link]  Tracks -> CLICK; [link]  Added any time -> CLICK; [link]  Past year -> SELECT; [link]  Any length -> CLICK; [link]  2-10 min -> CLICK; [link]  To listen to -> CLICK; [link]  To share -> CLICK \n\n" \
                "Subgoal-based plan:\n" \
                "Subgoal 1: Type Ricky Kej to search his songs.\n" \
                "Action 1-1: R1 = TYPE(Env, QUERY: Type Ricky Kej to search his songs, TEXT: Ricky Kej). \n\n" \
                "Subgoal 2: Click on the option to search for Ricky Rej.\n" \
                "Action 2-1: R2 = CLICK(R1, QUERY: Click on the option to search for Ricky Rej). \n\n" \
                "Subgoal 3: Choose tracks as the search category.\n" \
                "Action 3-1: R3 = CLICK(R2, QUERY: Choose tracks as the search category). \n\n" \
                "Subgoal 4: Find the region to adjust the added time of our interested track.\n" \
                "Action 4-1: R4 = CLICK(R3, QUERY: Find the region to adjust the added time of our interested track). \n\n" \
                "Subgoal 5: Choose the last year as the added date.\n" \
                "Action 5-1: R5 = SELECT(R4, QUERY: Choose the last year as the added date, TEXT: Past year). \n\n" \
                "Subgoal 6: Find the region to adjust the track length of our interested track.\n" \
                "Action 6-1: R6 = CLICK(R5, QUERY: Find the region to adjust the track length of our interested track). \n\n" \
                "Subgoal 7: Choose 2 to 10 minutes as the track length.\n" \
                "Action 7-1: R7 = CLICK(R6, QUERY: Choose 2 to 10 minutes as the track length). \n\n" \
                "Subgoal 8: Listen to our searched track.\n" \
                "Action 8-1: R8 = CLICK(R7, QUERY: Listen to our searched track). \n\n" \
                "Subgoal 9: Share our searched track.\n" \
                "Action 9-1: R9 = CLICK(R8, QUERY: Share our searched track). \n\n" \
                "Now please help us generate a plan consisting of subgoals according to the following instruction and its natural language plan! \n\n"